
package require itcl

proc try_it { setvar } {
  upvar $setvar myvar
  set myvar [collection::create "John"]
  set foo [collection::create "Harry"]
  set bar [collection::create "Sue"]
  puts "itcl-local variables"
  set local_vars [ info vars "itcl-local*" ]
  puts $local_vars
  foreach var $local_vars {
      puts "Trace info for $var: [ trace info variable $var ]"
  }

  # do some stuff with $foo and $bar - the same as if they were Tcl_Obj's 

  $foo do_something

  puts "changing foo"
  set foo 1

  puts "Nuking bar"
  unset bar

  puts "ready to return now."
  # the commands stored in foo and bar will be destroyed on exit from
  # the proc
}


# you'd accomplish this via an Itcl class

itcl::class collection {
  public proc create {data} {
    uplevel 1 [list itcl::local collection #auto $data]
  }
  constructor {data} {
    set m_data $data
  }
  destructor {
    puts "Collection containing $m_data is going bye-bye"
  }
  public method do_something {args} {
    puts "We would do something with $args in collection $m_data "
  }
  private variable m_data
}

# Note that this variable is never destroyed:
set topvar [collection::create "Tipper"]

set topvar 0
try_it topvar

puts "returned from try_it"
